<?php

namespace popp\ch10;

require_once("vendor/autoload.php");

use popp\test\BaseUnit;

use popp\r10\zestaw03\Army;
use popp\r10\zestaw03\Soldier;
use popp\r10\zestaw03\Tank;
use popp\r10\zestaw03\Runner;
use popp\r10\zestaw03\Archer;

class Batch03Test extends BaseUnit
{
    public function testArmy()
    {
        $tank =  new Tank();
        $tank2 = new Tank();
        $soldier = new Soldier();

        $army = new Army();
        $army->addUnit($soldier);
        $army->addUnit($tank);
        $army->addUnit($tank2);

        self::assertEquals(count($army->getUnits()), 3);
        $army->removeUnit($tank2);
        self::assertEquals(count($army->getUnits()), 2);
    }

    public function testArcher()
    {
        $archer = new Archer();
        $tank =  new Tank();
        try {
            $archer->addUnit($tank);
            self::fail("Oczekiwany wyjątek");
        } catch (\Exception $e) {
            self::assertEquals($e->getMessage(), "popp\\r10\\zestaw03\\Archer to liść");
        }
    }
}
